// > *** MoReFEM Doxygen information and copyright notice *** //
/*!
 * This file is part of the [MoReFEM](https://gitlab.inria.fr/MoReFEM/CoreLibrary/MoReFEM) library.
 * It is released under the LGPL v3 license; a copy is provided in the LICENSE file shipped with it.
 *
 * MoReFEM is mostly developed by [M3DISIM team-project](https://www.inria.fr/m3disim).
 * You may contact its developers by writing at morefem-maint@inria.fr.
 *
 * \file
 *
 * \ingroup TestGroup
 * \addtogroup TestGroup
 * @{
 */
// *** MoReFEM Doxygen information and copyright notice *** < //


#include <cstddef> // IWYU pragma: keep

#include "Test/Operators/VariationalInstances/Viscoelasticity/ExpectedResults.hpp"


// NOLINTBEGIN(cppcoreguidelines-avoid-magic-numbers,readability-magic-numbers)
namespace MoReFEM::TestNS::ViscoelasticityNS
{


    template<>
    expected_results_type<LinearAlgebraNS::type::matrix>
    GetExpectedMatrixP1P1<Advanced::LocalVariationalOperatorNS::SecondPiolaKirchhoffStressTensorNS::
                              ViscoelasticityPolicyNS::DerivatesWithRespectTo::displacement_and_velocity>()
    {
        constexpr auto f1 = 2.8086655333164203e+00;
        constexpr auto f2 = -1.7506479434845286e+01;
        constexpr auto f3 = 4.0166061923578056e+00;
        constexpr auto f4 = -1.5966777742754008e+01;
        constexpr auto f5 = -1.7486788029081183e+01;
        constexpr auto f6 = -1.0572939367936787e+01;

        return expected_results_type<LinearAlgebraNS::type::matrix>{

            { 4.6212686058895052e+01,
              2.6259614492360566e+00,
              -4.6777999309236371e+01,
              -1.2203367232637643e+01,
              -9.8899848715991965e+00,
              4.3842904493370547e+00,
              -1.9305559827556792e+01,
              -3.0383698748514556e+00,
              1.8052137497272696e+01,
              -1.4703758998700627e+01,
              1.0302393297214596e+01,
              2.4341571362626606e+01 },
            { 6.1846599660474402e+00,
              9.6732099838452470e+01,
              -2.0899147654098620e+01,
              -1.0612495860550434e+01,
              -3.5867001587373679e+01,
              2.9770372910297581e+01,
              4.1244377648325914e+00,
              -2.4796578940028546e+01,
              -2.9771286277783457e+01,
              3.0339812967040386e-01,
              -3.6068519311050210e+01,
              2.0900061021584477e+01 },
            { -4.5882149532733777e+01,
              -4.5896325186300544e+00,
              1.6237132341906482e+02,
              2.1352845104732339e+01,
              6.2068262402050873e+00,
              -5.3071355069463728e+01,
              1.8146749555461035e+01,
              1.2133802863636200e+01,
              -4.9423218385257663e+01,
              6.3825548725404095e+00,
              -1.3750996585211233e+01,
              -5.9876749964343425e+01 },
            { -1.2408271986157061e+01,
              -7.8282884187962587e+00,
              2.3081265594887615e+01,
              1.3763403108944271e+01,
              f1,
              f2,
              2.7087372053885841e+00,
              1.0247782793591921e-01,
              -1.1381173245921082e-01,
              -4.0638683281757979e+00,
              4.9171450575439186e+00,
              -5.4609744275831327e+00 },
            { -1.0107687757353830e+01,
              -3.8275147315479494e+01,
              1.0368371439830240e+01,
              f3,
              3.8605786478233696e+01,
              f4,
              1.0379447506652699e+01,
              -5.7573156397995833e+00,
              9.5399090821645949e+00,
              -4.2883659416566777e+00,
              5.4266764770454001e+00,
              -3.9415027792408228e+00 },
            { 5.6224590000231487e+00,
              2.0391686120590816e+01,
              -5.5885322957033615e+01,
              f5,
              f6,
              4.0270384877132656e+01,
              8.4141985419695631e-01,
              -6.9634687648838067e-01,
              3.6059265532137741e+00,
              1.1022909174861077e+01,
              -9.1223998761656411e+00,
              1.2009011526687182e+01 },
            { -1.9190634897337745e+01,
              4.5127084259585963e+00,
              1.8064517725592026e+01,
              2.8585980915927407e+00,
              1.0706829928799921e+01,
              8.1607920945145551e-01,
              1.4410028048912249e+01,
              f1,
              -1.7506479434845279e+01,
              1.9220087568327537e+00,
              -1.8028203888074934e+01,
              -1.3741175001982033e+00 },
            { -3.9575825488936918e+00,
              -1.9776005128544785e+01,
              1.7817014635888775e+01,
              -2.7385263092582709e-02,
              -8.4302471843286035e+00,
              -8.5845639354512049e-01,
              4.0166061923578100e+00,
              3.9252411418201660e+01,
              f4,
              -3.1638380371533728e-02,
              -1.1046159105328279e+01,
              -9.9178049958964420e-01 },
            { 1.7389412688832195e+01,
              -2.9474882494608117e+01,
              -4.8767880723650364e+01,
              1.6051358569291987e-02,
              6.6014860332312342e+00,
              3.3357328071255448e+00,
              f5,
              f6,
              4.0917009817100627e+01,
              8.1323981679696913e-02,
              3.3446335829313675e+01,
              4.5151380994241848e+00 },
            { -1.4613779175400241e+01,
              6.8961854360160801e-01,
              5.6322159887567178e+00,
              -4.4186339678993747e+00,
              -3.6255105905171447e+00,
              1.2306109776056768e+01,
              2.1867945732559515e+00,
              1.2722651359911571e-01,
              -4.3184632996820749e-01,
              1.6845618570043666e+01,
              f1,
              f2 },
            { 7.8806103402000840e+00,
              -3.8680947394428159e+01,
              -7.2862384216203884e+00,
              6.6232749312852084e+00,
              5.6914622934685983e+00,
              -1.2945138773998455e+01,
              -1.8520491463843097e+01,
              -8.6985168383735214e+00,
              3.6198154938372852e+01,
              f3,
              4.1688001939333077e+01,
              -1.5966777742754012e+01 },
            { 2.2870277843878455e+01,
              1.3672828892647352e+01,
              -5.7718119738380814e+01,
              -3.8821084342204557e+00,
              -2.2353729054995339e+00,
              9.4652373852055192e+00,
              -1.5013813805768164e+00,
              -8.6451661921103207e-01,
              4.9002820149432580e+00,
              -1.7486788029081186e+01,
              f6,
              4.3352600338232044e+01 }
        };
    }


    template<>
    expected_results_type<LinearAlgebraNS::type::vector>
    GetExpectedVectorP1P1<Advanced::LocalVariationalOperatorNS::SecondPiolaKirchhoffStressTensorNS::
                              ViscoelasticityPolicyNS::DerivatesWithRespectTo::displacement_and_velocity>()
    {
        return expected_results_type<LinearAlgebraNS::type::vector>{
            2.4985545370828355, -0.8709239322195668, -8.855154072237047,  -1.317393820675634,
            2.337240538619038,  2.2937270086654062,  -0.1770158969446071, -1.6502452152078242,
            2.889029931944329,  -1.004144819462594,  0.1839286088083532,  3.6723971316273096
        };
    }


} // namespace MoReFEM::TestNS::ViscoelasticityNS
// NOLINTEND(cppcoreguidelines-avoid-magic-numbers,readability-magic-numbers)

// > *** MoReFEM Doxygen end of group *** //
///@} // \addtogroup TestGroup
// *** MoReFEM Doxygen end of group *** < //
